/*****************************************************************
*B.LECLERC http://amazing-vacuum-tubes@e-monsite.com 
*Mesure de la saturation pulsée du sang en oxygène et de la 
*tachycardie du coeur avec circuit MAX30100 .... 
*****************************************************************/
#include <Wire.h>
#include "MAX30100_PulseOximeter.h"
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define ENABLE_MAX30100 1
#define OLED_RESET     4 
#define SCREEN_ADDRESS 0x3c //Adresse I2C de l'écran 

Adafruit_SSD1306 display(128, 32, &Wire, OLED_RESET);

#if ENABLE_MAX30100
#define REPORTING_PERIOD_MS     5000
PulseOximeter pox;
#endif
uint32_t tsLastReport = 0;


void setup() {
  if (!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    for (;;); // Don't proceed, loop forever
  }

#if ENABLE_MAX30100  // Initialise le PulseOximeter
  if (!pox.begin()) {
    for (;;);
  }
   
  pox.setIRLedCurrent(MAX30100_LED_CURR_7_6MA);
  pox.setOnBeatDetectedCallback(heart_beat); // Détection d'un battement de coeur et appel de l'affichage 
#endif
}
void loop()
{
#if ENABLE_MAX30100  // Mise à jour des données cycliquement...
  pox.update();
  int bpm = 0;
  int spo2 = 0;
  if (millis() - tsLastReport > REPORTING_PERIOD_MS) {
    bpm = pox.getHeartRate();
    spo2 = pox.getSpO2();
    tsLastReport = millis();
     display.clearDisplay();
    display_data(bpm, spo2);
  }
#endif

}
void display_data(int bpm, int spo2) {  //Séquence d'affichage des données 
  display.setTextSize(1); // Grosseur du texte
  display.setTextColor(WHITE); // en blanc: afficheur monochromatique
  display.setCursor(0,0);  // Position sur l'écran
  display.print("Cardio: ");
  display.print(bpm);
  display.print("  b/min");
  display.display();  // Affichage ...
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  display.print(" SpO2:   ");
  display.print(spo2);
  display.print("  %");
  display.display();
}

void heart_beat() {  // Affiche un 'coeur' si le battement est détecté 
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(100,16);
  display.print (char(03));
  display.display();

}
